/* Copyright 1989, 1990 by James Aspnes, David Applegate, and Bennet Yee */
/* See the file COPYING for distribution information */
#ifndef _INTERFACE_H
#define _INTERFACE_H

#include "db.h"
#include "config.h"

#define MAX_COMMAND_LEN MAX_STRLEN

/* provided by game */
extern datum connect_player (const char *name, const char *password);
extern void disconnect_player (datum player);
extern int process_command (datum player, const char *input);
extern int init_game (const char *infile, const char *outfile);
extern void dump_database (void);
extern void panic (const char *);
extern unsigned long next_event_time (void);    /* time of next event if nonzero */
extern void check_events (void);

/* provided by interface */
extern void notify (datum player, const char *text);
extern void emergency_shutdown (void);
extern void force_disconnect (datum player);
extern int shutdown_flag;       /* if 1, do a clean shutdown */

#endif /* _INTERFACE_H */
